#include "dog.h"


/***************************
* Chien de dbut de niveau *
***************************/
void initDogLevel(chien &dog)
{
    dog.x= -DOG_WIDTH;
    dog.y= 500;
    dog.RECT.w= DOG_WIDTH;
    dog.RECT.h= DOG_HEIGHT;
    dog.RECT.y= 0;
    dog.mvt_x= 9;
    dog.cptMove=0;
    dog.change= 1;
    dog.sniff_x= random(SCREEN_WIDTH/2-DOG_WIDTH);
    dog.cptSniff= 0;
    dog.sniff= false;
    dog.happy= false;
    dog.jumpUp= false;
    dog.jumpDown= false;
    dog.startLevel= false;
}

void operationDogLevel(SDL_Surface *screen, surfaces SUR, chien &dog)
{
//Dplacements
	if (dog.x>dog.sniff_x && dog.cptMove<2 && !dog.happy && !dog.sniff)
        dog.sniff=true;
	if(dog.sniff)
	{
        dog.cptSniff++;
		dog.change*=-1;
        dog.RECT.x+= DOG_WIDTH*dog.change;

		if(dog.cptSniff>6)
		{
		    dog.change= 1;
		    dog.sniff_x+= random(SCREEN_WIDTH/2-DOG_WIDTH);
		    dog.cptSniff= 0;
		    dog.sniff= false;
		}
	}
	else if(!dog.happy) //Cherche
	{
        dog.x+= dog.mvt_x;
        dog.cptMove=(dog.cptMove%4)+1;

        if(dog.x+DOG_WIDTH > SCREEN_WIDTH/2)
        {
            dog.happy=true;
            dog.RECT.y= DOG_HEIGHT;
            dog.RECT.x= 0;
            dog.cptMove=0;
        }
	}
	else if (!dog.jumpUp) //Content
    {
        dog.cptMove++;

        if(dog.cptMove> 3)
        {
            dog.jumpUp=true;
            dog.RECT.x= DOG_WIDTH;
            dog.cptMove= 4;
            dog.x+= 10;
            dog.y-= 40;
        }
    }
    else if (!dog.jumpDown) //Saute (monte)
    {
        dog.x+=10;
        dog.y-=dog.cptMove*6;
        dog.cptMove--;

        if(dog.cptMove< 0)
        {
            dog.jumpDown=true;
            dog.RECT.x= 2*DOG_WIDTH;
            dog.cptMove= 0;
        }
    }
    else //Saute (descend)
    {
        dog.x+=10;
        dog.cptMove++;
        dog.y+=dog.cptMove*6;

        if(dog.cptMove> 3)
            dog.startLevel=true;
    }

//Affichage
    if (!dog.happy && !dog.sniff) //Chien marchant et ne reniflant pas
        dog.RECT.x= dog.cptMove*DOG_WIDTH;

    if (!dog.jumpDown) //Chien devant l'arrire-plan
    {
        SDL_BlitSurface(SUR.backgroundGameBlit, NULL, screen, NULL);
        applySurface(dog.x, dog.y, SUR.dog, screen, &dog.RECT);
    }
    else //Chien derrire l'arrire-plan
    {
        applySurface(dog.x, dog.y, SUR.dog, screen, &dog.RECT);
        SDL_BlitSurface(SUR.backgroundGameBlit, NULL, screen, NULL);
    }
}

/************************
* Chien de fin de vague *
************************/
void initDogWave(chien &dog)
{
    dog.x= DOG_WAVE_X;
    dog.y= DOG_WAVE_Y;
    dog.mvt_y= -5;
    dog.change= 1;
}

void operationDogWave(SDL_Surface *screen, surfaces SUR, chien &dog, bool &endWave, int duckKilledInWave)
{
//Dplacements
    dog.y+= dog.mvt_y;

	if(dog.y<DOG_WAVE_Y-DOG_HEIGHT)
		dog.mvt_y*=-1;
	else if (dog.y>DOG_WAVE_Y)
	{
		dog.y-= dog.mvt_y;
		dog.mvt_y= -5;
		endWave=true;
	}

//Affichage
    if(duckKilledInWave==0)
    {
		dog.RECT.x+= DOG_WIDTH*dog.change;
		dog.change*=-1;
	}

    applySurface(dog.x, dog.y, SUR.dog, screen, &dog.RECT);
}


void colorDuckOnDog(chien &dog, duck d1, duck d2, int duckKilledInWave)
{
	switch(duckKilledInWave)
	{
		case 2:
			if(d1.color==d2.color) //Canard de mme couleur
			{
				dog.RECT.y= DOG_WAVE_TWO_SAME_DUCKS;
                dog.RECT.x= d1.color*DOG_WIDTH;
			}
			else //Canard de couleur diffrente
			{
				dog.RECT.y= DOG_WAVE_TWO_DIFFERENT_DUCKS;
				if(d1.color==0 || d2.color==0)
				{
					if(d1.color==1 || d2.color==1) //Noir et rouge
						dog.RECT.x= 0;
					else //Noir et bleu
						dog.RECT.x= DOG_WIDTH;
				}
				else //Bleu et rouge
					dog.RECT.x= 2*DOG_WIDTH;
			}
			break;
		case 1:
            dog.RECT.y= DOG_WAVE_ONE_DUCK;
            int color;

            if(d1.hit)
                color= d1.color;
            else
                color= d2.color;

			dog.RECT.x= color*DOG_WIDTH;
			break;
		case 0:
			dog.RECT.x= 0;
			dog.RECT.y= DOG_WAVE_MOCK;
			break;
		default:
			dog.RECT.x= 0;
			dog.RECT.y= DOG_WAVE_MOCK;
			break;
	}
}

