#ifndef DOG_H_INCLUDED
#define DOG_H_INCLUDED

#include "duck.h"

struct chien
{
    //Rfrence : coin suprieur gauche du rectangle
    int x;      //Ordonne
    int y;      //Abscisse
    int mvt_x;  //Mouvement horizontal
    int mvt_y;  //Mouvement vertical

    int cptMove;        //Compteur de mouvement
    int change;         //Changement entre 2 sprites
    int sniff_x;        //Ordonne o le chien renifle
    int cptSniff;       //Compteur pour renifler
    bool sniff;         //Renifle ou non
    bool happy;         //Content ou non
    bool jumpUp;        //Saut (monte) ou non
    bool jumpDown;      //Saut (descente) ou non
    bool startLevel;    //Dbut du niveau ou non
    SDL_Rect RECT;      //Rectangles de sprites
};

const int DOG_WIDTH= 114;
const int DOG_HEIGHT= 98;

const int DOG_WAVE_X= 325;
const int DOG_WAVE_Y= 498;

const int DOG_WAVE_TWO_SAME_DUCKS= 392;
const int DOG_WAVE_TWO_DIFFERENT_DUCKS= 490;
const int DOG_WAVE_ONE_DUCK= 294;
const int DOG_WAVE_MOCK= 196;

/******************** Nom de la fonction ********************
* initDogLevel                                              *
*********************** Auteur  Dates ***********************
* Guillaume Gamelas *** 16/12/2012                          *
************************ Description ************************
* Initialise le chien en dbut de niveau                    *
************************** Entres **************************
* Structure du chien                                        *
************************** Sorties **************************
*                                                           *
************************************************************/
void initDogLevel(chien &dog);

/******************** Nom de la fonction ********************
* operationDogLevel                                         *
*********************** Auteur  Dates ***********************
* Guillaume Gamelas *** 16/12/2012                          *
************************ Description ************************
* Gre le chien en dbut de niveau                          *
************************** Entres **************************
* Fentre                                                   *
* Images et sprites                                         *
* Structure du chien                                        *
************************** Sorties **************************
*                                                           *
************************************************************/
void operationDogLevel(SDL_Surface *screen, surfaces SUR, chien &dog);

/******************** Nom de la fonction ********************
* initDogWave                                               *
*********************** Auteur  Dates ***********************
* Guillaume Gamelas *** 14/12/2012                          *
************************ Description ************************
* Initialise le chien pour les vagues                       *
************************** Entres **************************
* Structure du chien                                        *
************************** Sorties **************************
*                                                           *
************************************************************/
void initDogWave(chien &dog);

/******************** Nom de la fonction ********************
* colorDuckOnDog                                            *
*********************** Auteur  Dates ***********************
* Guillaume Gamelas *** 14/12/2012                          *
************************ Description ************************
* Modifie le rectangle de lecture sur la feuille de sprite  *
************************** Entres **************************
* Structure du chien                                        *
* Structure du canard 1                                     *
* Structure du canard 2                                     *
* Nombre de canards tus lors de la vague                   *
************************** Sorties **************************
*                                                           *
************************************************************/
void colorDuckOnDog(chien &dog, duck d1, duck d2, int duckKilledInWave);

/******************** Nom de la fonction ********************
* operationDogWave                                          *
*********************** Auteur  Dates ***********************
* Guillaume Gamelas *** 14/12/2012                          *
************************ Description ************************
* Gre le chien en fin de vague    	                  	    *
************************** Entres **************************
* Fentre                                                   *
* Images et sprites                                         *
* Structure du chien                                        *
* Fin de la vague ou non                                    *
* Nombre de canards tus lors de la vague                   *
************************** Sorties **************************
*                                                           *
************************************************************/
void operationDogWave(SDL_Surface *screen, surfaces SUR, chien &dog, bool &endWave, int duckKilledInWave);

#endif // DOG_H_INCLUDED
