#ifndef DUCK_H_INCLUDED
#define DUCK_H_INCLUDED

#include "general.h"

struct duck
{
    //Rfrence : coin suprieur gauche du rectangle
	int x;          //Ordonne
	int y;          //Abscisse
	int w;          //Largeur
	int h;          //Hauteur
	float mvt_x;    //Mouvement horizontal
	float mvt_y;    //Mouvement vertical

	int color;      //Couleur
	int horizontal; //Orientation horizontale
	int vertical;   //Orientation verticale
	int wing;       //Battement d'aile
	int wingChange; //Changement des ailes

    int cptRandom;  //Compteur pour l'alatoire
    int limitCptRandom; //Indique la limite pour le compteur
    int tmpRandom;  //Valeur temporaire pour l'alatoire

	bool hit;               //Touch ou non
	int cpt;                //Compteur
	bool falling;           //En chute ou non
	int orientationFall;    //Orientation horizontale en chute libre
	bool escape;            //S'chappe ou non
	bool noDisplay;         //Ne pas afficher ou afficher

	SDL_Rect RECTPoints;	//Points du canard
	int points_x;           //Ordonne de position du rectangle de points

	SDL_Rect RECT;  //Rectangle de lecture sur la feuille de sprites
};
const int DUCK_TOTAL= 10;
const int DUCK_POINTS= 500;
const int DUCK_SIZE= 70;

const int SPEED_BLACK = 2;
const int SPEED_RED = 3;
const int SPEED_BLUE = 4;
const int SPEED_FALLING= 10;

const int RANDOM_LIMIT= 30;


/******************** Nom de la fonction ********************
* initDuckAlive                                             *
*********************** Auteur  Dates ***********************
* Tho Chassaigne *** 22/11/2012                            *
************************ Description ************************
* Initialise le canard vivant                               *
************************** Entres **************************
* Structure du canard                                       *
* Vitesse du niveau                                         *
************************** Sorties **************************
*                                                           *
************************************************************/
void initDuckAlive(duck &d, float speed);

/******************** Nom de la fonction ********************
* operationDuckAlive                                        *
*********************** Auteur  Dates ***********************
* Tho Chassaigne *** 29/11/2012                            *
************************ Description ************************
* Gre le canard vivant                                     *
************************** Entres **************************
* Structure du canard                                       *
* Fentre                                                   *
* Images et sprites                                         *
************************** Sorties **************************
*                                                           *
************************************************************/
void operationDuckAlive(duck &d, SDL_Surface *screen, surfaces SUR);

/******************** Nom de la fonction ********************
* initDuckDead                                              *
*********************** Auteur  Dates ***********************
* Tho Chassaigne *** 09/12/2012                            *
************************ Description ************************
* Initialise le canard mort                                 *
************************** Entres **************************
* Structure du canard                                       *
************************** Sorties **************************
*                                                           *
************************************************************/
void initDuckDead(duck &d);

/******************** Nom de la fonction ********************
* operationDuckDead                                         *
*********************** Auteur  Dates ***********************
* Tho Chassaigne *** 09/12/2012                            *
************************ Description ************************
* Gre le canard mort                                       *
************************** Entres **************************
* Structure du canard                                       *
* Fentre                                                   *
* Images et sprites                                         *
************************** Sorties **************************
*                                                           *
************************************************************/
void operationDuckDead(duck &d, SDL_Surface *screen, surfaces SUR);


/******************** Nom de la fonction ********************
* initEscapeDuck                                            *
*********************** Auteur  Dates ***********************
* Tho Chassaigne *** 11/12/2012                            *
************************ Description ************************
* Initialise le canard s'chappant                          *
************************** Entres **************************
* Structure du canard                                       *
************************** Sorties **************************
*                                                           *
************************************************************/
void initEscapeDuck(duck &d);

/******************** Nom de la fonction ********************
* operationEscapeDuck                                       *
*********************** Auteur  Dates ***********************
* Tho Chassaigne *** 09/12/2012                            *
************************ Description ************************
* Gre le canard mort                                       *
************************** Entres **************************
* Structure du canard                                       *
* Fentre                                                   *
* Images et sprites                                         *
************************** Sorties **************************
*                                                           *
************************************************************/
void operationEscapeDuck(duck &d, SDL_Surface *screen, surfaces SUR);

/******************** Nom de la fonction ********************
* operationDuck                                             *
*********************** Auteur  Dates ***********************
* Tho Chassaigne *** 29/11/2012                            *
************************ Description ************************
* Gre la globalit du canard                               *
************************** Entres **************************
* Structure du canard                                       *
* Fentre                                                   *
* Images et sprites                                         *
************************** Sorties **************************
*                                                           *
************************************************************/
void operationDuck(duck &d, SDL_Surface *screen, surfaces SUR);

/******************** Nom de la fonction ********************
* shoot                                                     *
*********************** Auteur  Dates ***********************
* Guillaume Gamelas *** 02/12/2012                          *
************************ Description ************************
* Gre les tirs                                             *
* Ordonne du curseur                                       *
* Abscisse du curseur                                       *
************************** Entres **************************
* Structure du canard                                       *
************************** Sorties **************************
* Tir sur le canard ou tir manqu                           *
************************************************************/
bool shoot(duck d, int m_x, int m_y);

#endif // DUCK_H_INCLUDED
