#include "game.h"

void game(SDL_Surface *screen, surfaces &SUR, SDL_Event &event, TTF_Font *font, bool &quit)
{
/********************************
* Initialisation des paramètres *
********************************/
    bool continueGame;
    int cpt=0;

    //*GAME OVER*
    SDL_Surface *TXTGameOver = NULL;
    SDL_Rect posTXTGameOver;
	initPositionRect(posTXTGameOver, GAMEOVER_X, GAMEOVER_Y);
    SDL_Color fontColorGameOver = {0, 0, 0};
	SDL_Color fond = {0, 193, 255};
	font = TTF_OpenFont("ressources/font/duck_hunt.ttf", 100);
    TXTGameOver = TTF_RenderText_Shaded(font, "Game Over", fontColorGameOver, fond);

    //Structures
    niveau lvl;
    lvl.number= 1;
    lvl.speed= 1;
    lvl.points= 0;

    chien dog;
    progression results;
    duck d1;
    duck d2;

    initSizeResults(results);

/****************
* Boucle de jeu *
****************/
    do
    {
        continueGame= level(screen, SUR, event, font, quit,
                            lvl , dog, results ,d1, d2);
        lvl.number++;
        lvl.speed+=LEVEL_SPEED_STEP; //La vitesse des canards augmente au fur et à mesure des niveaux
    } while(continueGame==true);

/************
* Game Over *
************/

	saveScores(lvl.points);
	
	while(!quit && cpt<100) //cpt=100 ----> 2 secondes
	{

		cpt++;

    //Fond d'écran
    SDL_BlitSurface(SUR.backgroundGame, NULL, screen, NULL);

    //Game Over
    SDL_BlitSurface(TXTGameOver, NULL, screen, &posTXTGameOver);

	//Mise à jour de l'écran
    SDL_Flip(screen);

    //Boucle évènement
		while(SDL_PollEvent(&event))
			switch(event.type)
			{
			    case SDL_QUIT: //Clic sur la croix
                    quit=true; //Fermeture du programme
                    break;
			}

		SDL_Delay(DELAY_GAMEOVER);
	}

/*************
* Fin de jeu *
*************/
	SDL_FreeSurface(TXTGameOver);
}

void saveScores(int points)
{
	fstream file;
	
	bool found = false;
	
	int i=0;
	int score = 0;
	int tabScores[TABLE_WIDTH];
	
	file.open(FILENAME.c_str(), ios::in);
  	
  	if (file.fail())
    {
  		cerr << "ouverture en lecture impossible" << endl;
      	exit(EXIT_FAILURE);
    }
	
	while (!file.eof()) //On remplit le tabScore avec le contenu du fichier
	{
		file >> score;
		tabScores[i] = score;
		i++;
		
		if (score < points && !found) //Si le score en fin de partie fait partie des meilleurs
		{
			found = true;
		}
	}
		
	if (found == true)
	{
		insertInTab(tabScores, points);
				
		file.close();
	
		file.open(FILENAME.c_str(), ios::out);
	
		if (file.fail())
	    {
	  		cerr << "ouverture en écriture impossible" << endl;
	      	exit(EXIT_FAILURE);
	    }
	
		for (i=0; i<TABLE_WIDTH; i++)
			file << tabScores[i] << " ";
	}
		
file.close();

}

void insertInTab(int p[], int n)
{
	bool found = false;
	int id = 0;
	int backup[TABLE_WIDTH];
	
	for(int k=0; k<TABLE_WIDTH; k++)//On copie le contenu de p[] dans backup[]
		backup[k] = p[k];
		
	for (int i=0; i<TABLE_WIDTH; i++)//Recherche de la case du tableau ou placer le score
	{
		if (p[i] < n && !found)
		{
			id = i;
			found = true;
		}
	}
			
	p[id] = n;//Insertion du score
	
	for(int j=id+1; j<TABLE_WIDTH; j++)//Fin remplissage tableau
		p[j] = backup[j-1];
		
}
