#include "general.h"

void initSurfaces(surfaces &SUR)
{
	SUR.backgroundMenu=     IMG_Load("ressources/sprites/menu.png");
    SUR.backgroundGame=     IMG_Load("ressources/sprites/backGame.png");
	SUR.backgroundGameBlit= loadImageWithColorKey("ressources/sprites/backGameBlit.png", 0, 0, 0);
	SUR.duck=               loadImageWithColorKey("ressources/sprites/duck.png", 228, 255, 0);
	SUR.points=             loadImageWithColorKey("ressources/sprites/points.png", 0, 0, 0);
    SUR.dog=                loadImageWithColorKey("ressources/sprites/dog.png", 228, 255, 0);
	SUR.loader= 		    IMG_Load("ressources/sprites/loader.png");
	SUR.results= 		    IMG_Load("ressources/sprites/results.png");
	SUR.target= 		    loadImageWithColorKey("ressources/sprites/target.png", 0, 0, 0);
	SUR.message=            NULL;
	SUR.pause= 		        loadImageWithColorKey("ressources/sprites/pause.png", 228, 255, 0);
}

void closeSurfaces(surfaces &SUR)
{
	SDL_FreeSurface(SUR.backgroundMenu);
	SDL_FreeSurface(SUR.backgroundGame);
	SDL_FreeSurface(SUR.backgroundGameBlit);
    SDL_FreeSurface(SUR.duck);
    SDL_FreeSurface(SUR.points);
    SDL_FreeSurface(SUR.dog);
    SDL_FreeSurface(SUR.loader);
    SDL_FreeSurface(SUR.results);
    SDL_FreeSurface(SUR.target);
    SDL_FreeSurface(SUR.message);
    SDL_FreeSurface(SUR.pause);
}

void initPositionRect(SDL_Rect &pos, int x, int y)
{
    pos.x=x;
    pos.y=y;
}

SDL_Surface *loadImageWithColorKey(string filename, int r, int g, int b)
{
    SDL_Surface* loadedImage = NULL;
    SDL_Surface* optimizedImage = NULL;
    loadedImage = IMG_Load( filename.c_str() );

    if( loadedImage != NULL )
    {
        optimizedImage = SDL_DisplayFormat( loadedImage );
        SDL_FreeSurface( loadedImage );

        if( optimizedImage != NULL )
        {
            Uint32 colorkey = SDL_MapRGB( optimizedImage->format, r, g, b );
            SDL_SetColorKey( optimizedImage, SDL_SRCCOLORKEY, colorkey );
        }

		return optimizedImage;
	}
	else
        error();
}

void applySurface(int x, int y, SDL_Surface *source, SDL_Surface *destination, SDL_Rect *clip)
{
    SDL_Rect offset;
    offset.x = x;
    offset.y = y;
    SDL_BlitSurface( source, clip, destination, &offset );
}

void showMessageScreen(string message,int x ,int y, TTF_Font *font,
                       int fontSize, SDL_Color textColor, SDL_Surface *screen, surfaces SUR)
{
	string mot="";
	string space=" ";
	int i= 0,
        j= message.find(space);

	while( j != string::npos )
    {
		mot=message.substr(i,j-i);
		if(mot != "")
    	{
			SUR.message=TTF_RenderText_Solid(font,mot.c_str(),textColor);
			applySurface(x,y,SUR.message,screen,NULL);
			x+=SUR.message->w;
		}
		x+=fontSize;
		i=j+1;
		j = message.find(space,i);
	}

	mot=message.substr(i);
	SUR.message=TTF_RenderText_Solid(font,mot.c_str(),textColor);
	applySurface(x-(SUR.message->w)/2,y,SUR.message,screen,NULL);
}

int random(int e)
{
    return (rand()%e);
}

void error()
{
    fstream fichierErreurSDL;
    fichierErreurSDL.open ("Error.txt", ios::out);
    fichierErreurSDL << SDL_GetError();
    fichierErreurSDL.close();
    exit(EXIT_FAILURE);
}
