#include "level.h"

bool level(SDL_Surface *screen, surfaces SUR, SDL_Event &event, TTF_Font *font, bool &quit,
           niveau &lvl, chien &dog, progression &results, duck &d1, duck &d2)
{
/********************************
* Initialisation des paramtres *
********************************/
	SDL_Color fontColorLevel = {0, 0, 0};
	font = TTF_OpenFont("ressources/font/duck_hunt.ttf", 100);

    lvl.duckKilled= 0,
    lvl.waveNum= 0;

    initDogLevel(dog);

    initColorResults(results);

/**********************************
* Affichage du niveau et du chien *
**********************************/
    //Texte "Niveau #"
    ostringstream msgLvl;
    msgLvl.flush();
    msgLvl.str("");
    msgLvl << "Niveau " << lvl.number;

	while(!quit && !dog.startLevel)
	{
    //Fond d'cran
        SDL_BlitSurface(SUR.backgroundGame, NULL, screen, NULL);

    //Texte "Niveau"
        showMessageScreen(msgLvl.str(), LEVEL_X, LEVEL_Y, font, LEVEL_INTERVAL_NUMBER,
                          fontColorLevel, screen, SUR);

    //Chien
        operationDogLevel(screen, SUR, dog);

    //Mise  jour de l'cran
        SDL_Flip(screen);

    //Boucle vnement
		while(SDL_PollEvent(&event))
			switch(event.type)
			{
                case SDL_QUIT: //Clic sur la croix
                    quit=true; //Fermeture du programme
                    break;
			}

		SDL_Delay(DELAY_LEVEL_START);
	}

/*******************************
* Boucle des vagues de canards *
*******************************/
    initDogWave(dog); //Initialisation du chien pour les vagues

    while (!quit && lvl.waveNum<WAVE_TOTAL)
    {
        lvl.duckKilled+=wave(screen, SUR, event, font, quit,
                         lvl, dog, results, d1, d2);
        lvl.waveNum++;
    }

/****************
* Fin du niveau *
****************/
    if (quit)
        return false;
    else if (lvl.duckKilled>=LEVEL_WIN)
    {
        if (lvl.duckKilled==DUCK_TOTAL) //Si tous les canards sont morts
            lvl.points+= LEVEL_PERFECT; //Bonus de points
        return true;
    }
    else
        return false;
}

int wave(SDL_Surface *screen, surfaces SUR, SDL_Event &event, TTF_Font *font, bool &quit,
         niveau &lvl, chien &dog, progression &results, duck &d1, duck &d2)
{
/********************************
* Initialisation des paramtres *
********************************/
//Canard
    initDuckAlive(d1, lvl.speed);
    initDuckAlive(d2, lvl.speed);

//Cartouches
    int loader= BULLETS_TOTAL;
	SDL_Rect RECTLoader;
	RECTLoader.y= 0;
	RECTLoader.w= LOADER_W;
	RECTLoader.h= LOADER_H;

//Points
	SDL_Color fontColorPoints = {255, 255, 255};
    font = TTF_OpenFont("ressources/font/duck_hunt.ttf", 22);

/**********************************
* Affichage des vagues de canards *
**********************************/
	while(!quit && (!d1.noDisplay || !d2.noDisplay))
	{
	//Fond d'cran
        SDL_BlitSurface(SUR.backgroundGame, NULL, screen, NULL);

	//Canard
        operationDuck(d1, screen, SUR);
        operationDuck(d2, screen, SUR);

    //Arrire-plan
        SDL_BlitSurface(SUR.backgroundGameBlit, NULL, screen, NULL);

    //Cartouches
        RECTLoader.x= loader*RECTLoader.w; //Slectionne l'image des balles selon le nombre de balles
        applySurface(LOADER_X, LOADER_Y, SUR.loader, screen, &RECTLoader);

    //Bilan
        applySurface(0*(RESULTS_SIZE+RESULTS_INTERVAL)+RESULTS_X, RESULTS_Y, SUR.results, screen, &results.RECT0);
        applySurface(1*(RESULTS_SIZE+RESULTS_INTERVAL)+RESULTS_X, RESULTS_Y, SUR.results, screen, &results.RECT1);
        applySurface(2*(RESULTS_SIZE+RESULTS_INTERVAL)+RESULTS_X, RESULTS_Y, SUR.results, screen, &results.RECT2);
        applySurface(3*(RESULTS_SIZE+RESULTS_INTERVAL)+RESULTS_X, RESULTS_Y, SUR.results, screen, &results.RECT3);
        applySurface(4*(RESULTS_SIZE+RESULTS_INTERVAL)+RESULTS_X, RESULTS_Y, SUR.results, screen, &results.RECT4);
        applySurface(5*(RESULTS_SIZE+RESULTS_INTERVAL)+RESULTS_X, RESULTS_Y, SUR.results, screen, &results.RECT5);
        applySurface(6*(RESULTS_SIZE+RESULTS_INTERVAL)+RESULTS_X, RESULTS_Y, SUR.results, screen, &results.RECT6);
        applySurface(7*(RESULTS_SIZE+RESULTS_INTERVAL)+RESULTS_X, RESULTS_Y, SUR.results, screen, &results.RECT7);
        applySurface(8*(RESULTS_SIZE+RESULTS_INTERVAL)+RESULTS_X, RESULTS_Y, SUR.results, screen, &results.RECT8);
        applySurface(9*(RESULTS_SIZE+RESULTS_INTERVAL)+RESULTS_X, RESULTS_Y, SUR.results, screen, &results.RECT9);

    //Points
        ostringstream mssg;
        mssg.flush();
        mssg.str("");
        mssg << lvl.points;

        showMessageScreen(mssg.str(), POINTS_X, POINTS_Y, font, 0, fontColorPoints, screen, SUR);

    //Curseur
        if(event.motion.x != 0 && event.motion.y != 0) //Si le curseur est dans la fentre
            applySurface(event.motion.x-TARGET_SIZE/2, event.motion.y-TARGET_SIZE/2, SUR.target, screen, NULL);

	//Mise  jour de l'cran
		SDL_Flip(screen);

    //Boucle vnement
		while(SDL_PollEvent(&event))
			switch(event.type)
			{
                case SDL_QUIT: //Clic sur la croix
                    quit=true; //Fermeture du programme
                    break;
                case SDL_MOUSEBUTTONDOWN:
                    if (event.button.button == SDL_BUTTON_LEFT && loader>0) //Clic gauche et au moins 1 cartouche
                    {
						loader--; //Perte d'1 balle
						if (shoot(d1, event.button.x, event.button.y) && !d1.hit) //Si tir sur canard
						{
							lvl.points+=(d1.color+1)*DUCK_POINTS; //Ajout de points suivant la couleur
							resultsGreenDuck1(results, lvl.waveNum); //Bilan modifi en consquence
							initDuckDead(d1); //Initialisation de l'animation du canard mort
						}
						else if (shoot(d2, event.button.x, event.button.y) && !d2.hit) //Si tir sur canard
						{
							lvl.points+=(d2.color+1)*DUCK_POINTS; //Ajout de points suivant la couleur
							resultsGreenDuck2(results, lvl.waveNum); //Bilan modifi en consquence
							initDuckDead(d2); //Initialisation de l'animation du canard mort
						}

						if (loader < 1) //Si 0 balle
						{
							initEscapeDuck(d1); //Les canards s'chappent
							initEscapeDuck(d2);
                            resultsRed(results, lvl.waveNum); //Bilan modifi en consquence
						}
					}
					if (event.button.button == SDL_BUTTON_RIGHT)
					{
					    pause(screen, SUR, quit, event.button.x, event.button.y);
					}
                    break;
			}

		SDL_Delay(DELAY_WAVE);
	}
	if(loader == 1) //S'il reste une balle
		lvl.points+=LAST_BULLET_POINTS; //Gain de points

/*************************************
* Affichage du chien en fin de vague *
*************************************/
    int duckKilledInWave= countDuckKilled(d1, d2); //Compte le nombre de canards tus
    bool endWave=false;
    dog.change= 1; //Initialisation du paramtre pour le changement entre 2 sprites

    colorDuckOnDog(dog, d1, d2, duckKilledInWave); //Slectionne l'animation du chien

    while(!endWave && !quit)
    {
	//Fond d'cran
		SDL_BlitSurface(SUR.backgroundGame, NULL, screen, NULL);

	//Chien
		operationDogWave(screen, SUR, dog, endWave, duckKilledInWave);

	//Arrire-plan
		SDL_BlitSurface(SUR.backgroundGameBlit, NULL, screen, NULL);

	//Cartouches
		RECTLoader.x= loader*RECTLoader.w; //Slectionne l'image des balles selon le nombre de balles
		applySurface(LOADER_X, LOADER_Y, SUR.loader, screen, &RECTLoader);

    //Bilan
        applySurface(0*(RESULTS_SIZE+RESULTS_INTERVAL)+RESULTS_X, RESULTS_Y, SUR.results, screen, &results.RECT0);
        applySurface(1*(RESULTS_SIZE+RESULTS_INTERVAL)+RESULTS_X, RESULTS_Y, SUR.results, screen, &results.RECT1);
        applySurface(2*(RESULTS_SIZE+RESULTS_INTERVAL)+RESULTS_X, RESULTS_Y, SUR.results, screen, &results.RECT2);
        applySurface(3*(RESULTS_SIZE+RESULTS_INTERVAL)+RESULTS_X, RESULTS_Y, SUR.results, screen, &results.RECT3);
        applySurface(4*(RESULTS_SIZE+RESULTS_INTERVAL)+RESULTS_X, RESULTS_Y, SUR.results, screen, &results.RECT4);
        applySurface(5*(RESULTS_SIZE+RESULTS_INTERVAL)+RESULTS_X, RESULTS_Y, SUR.results, screen, &results.RECT5);
        applySurface(6*(RESULTS_SIZE+RESULTS_INTERVAL)+RESULTS_X, RESULTS_Y, SUR.results, screen, &results.RECT6);
        applySurface(7*(RESULTS_SIZE+RESULTS_INTERVAL)+RESULTS_X, RESULTS_Y, SUR.results, screen, &results.RECT7);
        applySurface(8*(RESULTS_SIZE+RESULTS_INTERVAL)+RESULTS_X, RESULTS_Y, SUR.results, screen, &results.RECT8);
        applySurface(9*(RESULTS_SIZE+RESULTS_INTERVAL)+RESULTS_X, RESULTS_Y, SUR.results, screen, &results.RECT9);

	//Points
		ostringstream mssg;
		mssg.flush();
		mssg.str("");
		mssg << lvl.points;

		showMessageScreen(mssg.str(), POINTS_X, POINTS_Y, font, 0, fontColorPoints, screen, SUR);

	//Mise  jour de l'cran
		SDL_Flip(screen);

    //Boucle vnement
		while(SDL_PollEvent(&event))
			switch(event.type)
			{
                case SDL_QUIT: //Clic sur la croix
                    quit=true; //Le programme se ferme
                    break;
			}
		SDL_Delay(DELAY_END_WAVE);
    }

    return duckKilledInWave;
}

void pause(SDL_Surface *screen, surfaces SUR, bool &quit, int mouse_x, int mouse_y)
{
    SDL_Event event;
    bool pause= false;

//Pause
    applySurface(PAUSE_X, PAUSE_Y, SUR.pause, screen);
//Mise  jour de l'cran
    SDL_Flip(screen);

    while(!pause)
        while(SDL_PollEvent(&event))
            switch(event.type)
            {
                case SDL_QUIT: //Clic sur la croix
                    quit=true; //Fermeture du programme
                    break;
                case SDL_MOUSEBUTTONDOWN:
                    if (event.button.button == SDL_BUTTON_RIGHT)
                        pause= true;
                    break;
            }

    SDL_WarpMouse(mouse_x, mouse_y); //On dplace la souris  l'endroit o elle tait avant la pause
}

int countDuckKilled(duck d1, duck d2)
{
    if (d1.hit && d2.hit)
        return 2;
    else if (d1.hit || d2.hit)
        return 1;
    else
        return 0;
}

void initSizeResults(progression &results)
{
    results.RECT0.w= results.RECT0.h= RESULTS_SIZE;
    results.RECT1.w= results.RECT1.h= RESULTS_SIZE;
    results.RECT2.w= results.RECT2.h= RESULTS_SIZE;
    results.RECT3.w= results.RECT3.h= RESULTS_SIZE;
    results.RECT4.w= results.RECT4.h= RESULTS_SIZE;
    results.RECT5.w= results.RECT5.h= RESULTS_SIZE;
    results.RECT6.w= results.RECT6.h= RESULTS_SIZE;
    results.RECT7.w= results.RECT7.h= RESULTS_SIZE;
    results.RECT8.w= results.RECT8.h= RESULTS_SIZE;
    results.RECT9.w= results.RECT9.h= RESULTS_SIZE;
}

void initColorResults(progression &results)
{
    results.RECT0.x= results.RECT0.y= 0;
    results.RECT1.x= results.RECT1.y= 0;
    results.RECT2.x= results.RECT2.y= 0;
    results.RECT3.x= results.RECT3.y= 0;
    results.RECT4.x= results.RECT4.y= 0;
    results.RECT5.x= results.RECT5.y= 0;
    results.RECT6.x= results.RECT6.y= 0;
    results.RECT7.x= results.RECT7.y= 0;
    results.RECT8.x= results.RECT8.y= 0;
    results.RECT9.x= results.RECT9.y= 0;
}

void resultsGreenDuck1(progression &results, int waveNum)
{
    switch(waveNum)
    {
        case 0:
            results.RECT0.x= 2*RESULTS_SIZE;
            break;
        case 1:
            results.RECT2.x= 2*RESULTS_SIZE;
            break;
        case 2:
            results.RECT4.x= 2*RESULTS_SIZE;
            break;
        case 3:
            results.RECT6.x= 2*RESULTS_SIZE;
            break;
        case 4:
            results.RECT8.x= 2*RESULTS_SIZE;
            break;
    }
}

void resultsGreenDuck2(progression &results, int waveNum)
{
    switch(waveNum)
    {
        case 0:
            results.RECT1.x= 2*RESULTS_SIZE;
            break;
        case 1:
            results.RECT3.x= 2*RESULTS_SIZE;
            break;
        case 2:
            results.RECT5.x= 2*RESULTS_SIZE;
            break;
        case 3:
            results.RECT7.x= 2*RESULTS_SIZE;
            break;
        case 4:
            results.RECT9.x= 2*RESULTS_SIZE;
            break;
    }
}

void resultsRed(progression &results, int waveNum)
{
    switch(waveNum)
        {
        case 0:
            if (results.RECT0.x!= 2*RESULTS_SIZE)
                results.RECT0.x= RESULTS_SIZE;
            if (results.RECT1.x!= 2*RESULTS_SIZE)
                results.RECT1.x= RESULTS_SIZE;
            break;
        case 1:
            if (results.RECT2.x!= 2*RESULTS_SIZE)
                results.RECT2.x= RESULTS_SIZE;
            if (results.RECT3.x!= 2*RESULTS_SIZE)
                results.RECT3.x= RESULTS_SIZE;
            break;
        case 2:
            if (results.RECT4.x!= 2*RESULTS_SIZE)
                results.RECT4.x= RESULTS_SIZE;
            if (results.RECT5.x!= 2*RESULTS_SIZE)
                results.RECT5.x= RESULTS_SIZE;
            break;
        case 3:
            if (results.RECT6.x!= 2*RESULTS_SIZE)
                results.RECT6.x= RESULTS_SIZE;
            if (results.RECT7.x!= 2*RESULTS_SIZE)
                results.RECT7.x= RESULTS_SIZE;
            break;
        case 4:
            if (results.RECT8.x!= 2*RESULTS_SIZE)
                results.RECT8.x= RESULTS_SIZE;
            if (results.RECT9.x!= 2*RESULTS_SIZE)
                results.RECT9.x= RESULTS_SIZE;
            break;
        }
}
