#ifndef LEVEL_H_INCLUDED
#define LEVEL_H_INCLUDED

#include "dog.h"

#include <sstream>

struct niveau
{
    int number;
    float speed;
    int waveNum;
    int duckKilled;
    int points;
};

struct progression
{
    SDL_Rect RECT0;
    SDL_Rect RECT1;
    SDL_Rect RECT2;
    SDL_Rect RECT3;
    SDL_Rect RECT4;
    SDL_Rect RECT5;
    SDL_Rect RECT6;
    SDL_Rect RECT7;
    SDL_Rect RECT8;
    SDL_Rect RECT9;
};

const int LEVEL_WIN= 6;
const int WAVE_TOTAL= 5;

const int LEVEL_X= 200;
const int LEVEL_Y= 150;
const int LEVEL_INTERVAL_NUMBER= 100;
const float LEVEL_SPEED_STEP= 0.5;
const int LEVEL_PERFECT= 2000;

const int BULLETS_TOTAL= 3;
const int LOADER_X= 69;
const int LOADER_Y= 659;
const int LOADER_W= 66;
const int LOADER_H= 47;
const int LAST_BULLET_POINTS= 500;

const int RESULTS_X= 189;
const int RESULTS_Y= 672;
const int RESULTS_SIZE= 23;
const int RESULTS_INTERVAL= 10;

const int POINTS_X= 632;
const int POINTS_Y= 673;

const int TARGET_SIZE= 30;

const int PAUSE_X= (SCREEN_WIDTH-98)/2;
const int PAUSE_Y= (BOTTOM_SHOOTING_RANGE-66)/2;

const int DELAY_LEVEL_START= 75;
const int DELAY_WAVE= 10;
const int DELAY_END_WAVE= 25;

/******************** Nom de la fonction ********************
* level                                                     *
*********************** Auteur  Dates ***********************
* Guillaume Gamelas & Tho Chassaigne *** 05/12/2012        *
************************ Description ************************
* Gestion des niveaux                                       *
************************** Entres **************************
* Fentre                                                   *
* Images et sprites                                         *
* Variable des vnements                                   *
* Police d'criture                                         *
* Boolen de fermeture du programme                         *
*                                                           *
* Structure du niveau                                       *
* Structure du chien                                        *
* Rectangles de lecture du bilan des canards                *
* Structure du canard 1                                     *
* Structure du canard 2                                     *
************************** Sorties **************************
* Niveau gagn ou perdu                                     *
************************************************************/
bool level(SDL_Surface *screen, surfaces SUR, SDL_Event &event, TTF_Font *font, bool &quit,
           niveau &lvl, chien &dog, progression &results, duck &d1, duck &d2);

/******************** Nom de la fonction ********************
* wave                                                      *
*********************** Auteur  Dates ***********************
* Guillaume Gamelas & Tho Chassaigne *** 05/12/2012        *
************************ Description ************************
* Gre les vagues                                           *
************************** Entres **************************
* Fentre                                                   *
* Images et sprites                                         *
* Variable des vnements                                   *
* Police d'criture                                         *
* Boolen de fermeture du programme                         *
*                                                           *
* Structure du niveau                                       *
* Structure du chien                                        *
* Rectangles de lecture du bilan des canards                *
* Structure du canard 1                                     *
* Structure du canard 2                                     *
************************** Sorties **************************
* Nombre de canards tus                                    *
************************************************************/
int wave(SDL_Surface *screen, surfaces SUR, SDL_Event &event, TTF_Font *font, bool &quit,
         niveau &lvl, chien &dog, progression &results, duck &d1, duck &d2);

/******************** Nom de la fonction ********************
* pause                                                     *
*********************** Auteur  Dates ***********************
* Guillaume Gamelas *** 19/12/2012                          *
************************ Description ************************
* Gre la pause durant le jeu                               *
************************** Entres **************************
* Fentre                                                   *
* Images et sprites                                         *
* Boolen de fermeture du programme                         *
* Ordonne de la souris                                     *
* Abscisse de la souris                                     *
************************** Sorties **************************
*                                                           *
************************************************************/
void pause(SDL_Surface *screen, surfaces SUR, bool &quit, int mouse_x, int mouse_y);

/******************** Nom de la fonction ********************
* moveDuckEscape                                            *
*********************** Auteur  Dates ***********************
* Tho Chassaigne *** 15/12/2012                            *
************************ Description ************************
* Compte les canards tus dans la vague                     *
************************** Entres **************************
* Structure du canard 1                                     *
* Structure du canard 2                                     *
************************** Sorties **************************
* Nombre de canards tus                                    *
************************************************************/
int countDuckKilled(duck d1, duck d2);

/******************** Nom de la fonction ********************
* initSizeResults                                           *
*********************** Auteur  Dates ***********************
* Guillaume Gamelas *** 18/12/2012                          *
************************ Description ************************
* Initialise la taille des rectangles de lecture du bilan   *
************************** Entres **************************
* Rectangles de lecture du bilan des canards                *
************************** Sorties **************************
*                                                           *
************************************************************/
void initSizeResults(progression &results);

/******************** Nom de la fonction ********************
* initColorResults                                          *
*********************** Auteur  Dates ***********************
* Guillaume Gamelas *** 18/12/2012                          *
************************ Description ************************
* Initialise la couleur des rectangles de lecture du bilan  *
************************** Entres **************************
* Rectangles de lecture du bilan des canards                *
************************** Sorties **************************
*                                                           *
************************************************************/
void initColorResults(progression &results);

/******************** Nom de la fonction ********************
* resultsGreenDuck1                                         *
*********************** Auteur  Dates ***********************
* Guillaume Gamelas *** 12/12/2012                          *
************************ Description ************************
* Passe le canard 1 du bilan en vert                        *
************************** Entres **************************
* Rectangles de lecture du bilan des canards                *
* Numro de la vague                                        *
************************** Sorties **************************
*                                                           *
************************************************************/
void resultsGreenDuck1(progression &results, int waveNum);

/******************** Nom de la fonction ********************
* resultsGreenDuck2                                         *
*********************** Auteur  Dates ***********************
* Guillaume Gamelas *** 12/12/2012                          *
************************ Description ************************
* Passe le canard 2 du bilan en vert                        *
************************** Entres **************************
* Rectangles de lecture du bilan des canards                *
* Numro de la vague                                        *
************************** Sorties **************************
*                                                           *
************************************************************/
void resultsGreenDuck2(progression &results, int waveNum);

/******************** Nom de la fonction ********************
* resultsRed                                                *
*********************** Auteur  Dates ***********************
* Guillaume Gamelas *** 12/12/2012                          *
************************ Description ************************
* Passe le canard du bilan en rouge                         *
************************** Entres **************************
* Rectangles de lecture du bilan des canards                *
* Numro de la vague                                        *
************************** Sorties **************************
*                                                           *
************************************************************/
void resultsRed(progression &results, int waveNum);

#endif // LEVEL_H_INCLUDED
