#include "menu.h"

int menu(SDL_Surface *screen, surfaces &SUR, SDL_Event &event, TTF_Font *font, bool &quit)
{
/********************************
* Initialisation des paramtres *
********************************/
    bool validated= false;
    int choice;

	font = TTF_OpenFont("ressources/font/duck_hunt.ttf", 100);

	texte TXT;
	initTexte(TXT, font);

/********************
* Affichage du menu *
********************/
	while(!quit && !validated)
	{
    //Fond d'cran
        SDL_BlitSurface(SUR.backgroundMenu, NULL, screen, NULL);

    //Texte "PLAY"
        if(mouseInRectangle(TXT.posP, event.button.x, event.button.y)) //Si la souris est sur "PLAY"
            SDL_BlitSurface(TXT.playSelect, NULL, screen, &TXT.posP); //"PLAY" change de couleur
        else
            SDL_BlitSurface(TXT.playNormal, NULL, screen, &TXT.posP); //Sinon, "PLAY" reste en noir

	//Texte "HIGH SCORE"
		if(mouseInRectangle(TXT.posS, event.button.x, event.button.y)) //Si la souris est sur "SCORES"
            SDL_BlitSurface(TXT.scoreSelect, NULL, screen, &TXT.posS); //"SCORES" change de couleur
        else
            SDL_BlitSurface(TXT.scoreNormal, NULL, screen, &TXT.posS); //Sinon, "SCORES" reste en noir


    //Texte "QUIT"
        if(mouseInRectangle(TXT.posQ, event.button.x, event.button.y)) //Si la souris est sur "QUIT"
            SDL_BlitSurface(TXT.quitSelect, NULL, screen, &TXT.posQ); //"QUIT" change de couleur
        else
            SDL_BlitSurface(TXT.quitNormal, NULL, screen, &TXT.posQ); //Sinon, "QUIT" reste en noir

    //Curseur
        if(event.motion.x != 0 && event.motion.y != 0) //Si le curseur est dans la fentre
            applySurface(event.motion.x-TARGET_SIZE/2, event.motion.y-TARGET_SIZE/2, SUR.target, screen, NULL);

    //Mis  Jour de l'cran
		SDL_Flip(screen);

    //Boucle vnement
		while(SDL_PollEvent(&event))
			switch(event.type)
			{
                case SDL_QUIT: //Clic sur la croix
                    quit=true; //Fermeture du programme
                    break;
                case SDL_MOUSEBUTTONDOWN: //Clic de la souris
                    if(mouseInRectangle(TXT.posP, event.button.x, event.button.y))
                    { //Si la souris est sur "PLAY"
                        choice= 1;
                        validated= true;
                    }
                    if(mouseInRectangle(TXT.posS, event.button.x, event.button.y))
                    { //Si la souris est sur "SCORES"
                        choice= 2;
                        validated= true;
                    }
                    if(mouseInRectangle(TXT.posQ, event.button.x, event.button.y))
                    { //Si la souris est sur "QUIT"
                        choice= 0;
                        validated= true;
                    }
			}
        SDL_Delay(DELAY_MENU);
	}

/*********************
* Fin de la fonction *
*********************/
    closeTexte(TXT);

	return choice;
}

void initTexte(texte &TXT, TTF_Font *font)
{
    SDL_Color couleurNoire = {0, 0, 0};
    SDL_Color couleurSelection = {255, 204, 102};
    SDL_Color couleurFond = {0, 136, 255};

	initPositionRect(TXT.posP, 150, 100);
	initPositionRect(TXT.posS, 150, 200);
	initPositionRect(TXT.posQ, 150, 300);

	TXT.playNormal = TTF_RenderText_Shaded(font, "PLAY", couleurNoire, couleurFond);
	TXT.playSelect = TTF_RenderText_Shaded(font, "PLAY", couleurSelection, couleurFond);
	TXT.scoreNormal = TTF_RenderText_Shaded(font, "SCORES", couleurNoire, couleurFond);
	TXT.scoreSelect = TTF_RenderText_Shaded(font, "SCORES", couleurSelection, couleurFond);
	TXT.quitNormal = TTF_RenderText_Shaded(font, "QUIT", couleurNoire, couleurFond);
	TXT.quitSelect = TTF_RenderText_Shaded(font, "QUIT", couleurSelection, couleurFond);
}

void initTexteScore(texte &TXT, TTF_Font *font, int tab[])
{
    SDL_Color couleurNoire = {0, 0, 0};
    SDL_Color couleurSelection = {255, 204, 102};
    SDL_Color couleurFond = {0, 136, 255};
    
    string scores[TABLE_WIDTH];
    ostringstream tmp0, tmp1, tmp2, tmp3, tmp4;
    
    //Conversion des int du tab[] en string pour pouvoir les afficher
    
    tmp0 << tab[0];
    tmp1 << tab[1];
    tmp2 << tab[2];
    tmp3 << tab[3];
    tmp4 << tab[4];
    
    scores[0] = tmp0.str();
    scores[1] = tmp1.str();
    scores[2] = tmp2.str();
    scores[3] = tmp3.str();
    scores[4] = tmp4.str();
		
	font = TTF_OpenFont("ressources/font/duck_hunt.ttf", 30);
    
	initPositionRect(TXT.posQ, 150, 390);
	TXT.quitNormal = TTF_RenderText_Shaded(font, "QUIT", couleurNoire, couleurFond);
	TXT.quitSelect = TTF_RenderText_Shaded(font, "QUIT", couleurSelection, couleurFond);

	initPositionRect(TXT.posHead, 150, 100);
	TXT.headHighScore = TTF_RenderText_Shaded(font, "HIGH SCORES", couleurNoire, couleurFond);

	initPositionRect(TXT.posP, 150, 160);
	initPositionRect(TXT.posS, 150, 190);
	initPositionRect(TXT.posS1, 150, 220);
	initPositionRect(TXT.posS2, 150, 250);
	initPositionRect(TXT.posS3, 150, 280);
	
	TXT.playNormal = TTF_RenderText_Shaded(font, scores[0].c_str(), couleurSelection, couleurFond);
	TXT.playSelect = TTF_RenderText_Shaded(font, scores[1].c_str(), couleurSelection, couleurFond);
	TXT.scoreNormal = TTF_RenderText_Shaded(font, scores[2].c_str(), couleurSelection, couleurFond);
	TXT.scoreSelect = TTF_RenderText_Shaded(font, scores[3].c_str(), couleurSelection, couleurFond);
	TXT.scoreExtra = TTF_RenderText_Shaded(font, scores[4].c_str(), couleurSelection, couleurFond);
}

void closeTexte(texte &TXT)
{
    SDL_FreeSurface(TXT.playNormal);
    SDL_FreeSurface(TXT.playSelect);
    SDL_FreeSurface(TXT.scoreNormal);
    SDL_FreeSurface(TXT.scoreSelect);
    SDL_FreeSurface(TXT.quitNormal);
    SDL_FreeSurface(TXT.quitSelect);
}

bool mouseInRectangle(SDL_Rect txt, int m_x, int m_y)
{
	if((txt.y + txt.h) < m_y || (txt.y) > m_y || (txt.x) > m_x || (txt.x + txt.w) < m_x )
    	return false;

	return true;
}

void printScores(SDL_Surface *screen, surfaces &SUR, SDL_Event &event, TTF_Font *font, bool &quit)
{
	bool close= false;
    
/***********************
* Manipulation fichier *
***********************/
      
       	fstream file;
		int tabScores[TABLE_WIDTH];
		int i=0, score=0;
	
		file.open(FILENAME.c_str(), ios::in);
  	
  		if (file.fail())
    	{
  			cerr << "ouverture en lecture impossible" << endl;
    	  	exit(EXIT_FAILURE);
    	}
	
		while (!file.eof())
		{
			file >> score;
			tabScores[i] = score; //Remplissage du tableau avec les scores du fichier
			i++;
		}
		
		file.close();
		
/*******************
* Fin manipulation *
*******************/

	texte TXT;
	
	initTexteScore(TXT, font, tabScores);

	while(!quit && !close)
	{
        SDL_BlitSurface(SUR.backgroundMenu, NULL, screen, NULL);
         
        if(mouseInRectangle(TXT.posQ, event.button.x, event.button.y)) //Si la souris est sur "QUIT"
            SDL_BlitSurface(TXT.quitSelect, NULL, screen, &TXT.posQ); //"QUIT" change de couleur
        else
            SDL_BlitSurface(TXT.quitNormal, NULL, screen, &TXT.posQ); //Sinon, "QUIT" reste en noir
		
		SDL_BlitSurface(TXT.headHighScore, NULL, screen, &TXT.posHead);

		//Affichage scores
		SDL_BlitSurface(TXT.playNormal, NULL, screen, &TXT.posP);
		SDL_BlitSurface(TXT.playSelect, NULL, screen, &TXT.posS);
		SDL_BlitSurface(TXT.scoreNormal, NULL, screen, &TXT.posS1);
		SDL_BlitSurface(TXT.scoreSelect, NULL, screen, &TXT.posS2);
		SDL_BlitSurface(TXT.scoreExtra, NULL, screen, &TXT.posS3);

        if(event.motion.x != 0 && event.motion.y != 0) //Si le curseur est dans la fentre
            applySurface(event.motion.x-TARGET_SIZE/2, event.motion.y-TARGET_SIZE/2, SUR.target, screen, NULL);

		SDL_Flip(screen);

    //Boucle vnement
		while(SDL_PollEvent(&event))
			switch(event.type)
			{
                case SDL_QUIT:
                    quit=true;
                    break;
                case SDL_MOUSEBUTTONDOWN:
                    if(mouseInRectangle(TXT.posQ, event.button.x, event.button.y))
                        close= true;
			}
        SDL_Delay(DELAY_MENU);
	}

/*********************
* Fin de la fonction *
*********************/
    closeTexte(TXT);
}

