#ifndef MENU_H_INCLUDED
#define MENU_H_INCLUDED

#include "level.h"
#include "general.h"
#include "game.h"

struct texte
{
    SDL_Surface *playNormal;
    SDL_Surface *playSelect;
    SDL_Surface *scoreNormal;
    SDL_Surface *scoreSelect;
    SDL_Surface *quitNormal;
    SDL_Surface *quitSelect;
    
    SDL_Surface *headHighScore;
    SDL_Surface *scoreExtra;

	SDL_Rect posP;
    SDL_Rect posQ;
    SDL_Rect posS;	
    SDL_Rect posHead;
    SDL_Rect posS1;
    SDL_Rect posS2;
    SDL_Rect posS3;
    
};

const int DELAY_MENU= 20;

/******************** Nom de la fonction ********************
* menu                                                      *
*********************** Auteur  Dates ***********************
* Guillaume Gamelas / Tho Chassaigne*** 20/11/2012                          *
************************ Description ************************
* Gre le menu                                              *
************************** Entres **************************
* Fentre                                                   *
* Images et sprites                                         *
* Variable des vnements                                   *
* Police d'criture                                         *
*                                                           *
* Boolen de fermeture du programme                         *
************************** Sorties **************************
* Rentre dans le jeu, les scores, ou quitte le programme    *
************************************************************/
int menu(SDL_Surface *screen, surfaces &SUR, SDL_Event &event, TTF_Font *font, bool &quit);

/******************** Nom de la fonction ********************
* initTexte                                                 *
*********************** Auteur  Dates ***********************
* Guillaume Gamelas *** 16/12/2012                          *
************************ Description ************************
* Initialise le texte                                       *
************************** Entres **************************
* Structure de texte                                        *
* Police d'criture                                         *
************************** Sorties **************************
*                                                           *
************************************************************/
void initTexte(texte &TXT, TTF_Font *font);

/******************** Nom de la fonction ********************
* initTexte                                                 *
*********************** Auteur  Dates ***********************
* Tho Chassaigne *** 20/12/2012                            *
************************ Description ************************
* Initialise le texte pour l'affichage des scores           *
************************** Entres **************************
* Structure de texte                                        *
* Police d'criture                                         *  
* Tableau des scores                                        *
************************** Sorties **************************
*                                                           *
************************************************************/
void initTexteScore(texte &TXT, TTF_Font *font, int tab[]);

/******************** Nom de la fonction ********************
* closeTexte                                                *
*********************** Auteur  Dates ***********************
* Guillaume Gamelas *** 16/12/2012                          *
************************ Description ************************
* Libre la mmoire qu'occupe le texte                      *
************************** Entres **************************
* Structure de texte                                        *
************************** Sorties **************************
*                                                           *
************************************************************/
void closeTexte(texte &TXT);

/******************** Nom de la fonction ********************
* shoot                                                     *
*********************** Auteur  Dates ***********************
* Guillaume Gamelas *** 12/12/2012                          *
************************ Description ************************
* Gre la slection des rectangles de texte                 *
************************** Entres **************************
* Rectangle de texte                                        *
* Ordonne du curseur                                       *
* Abscisse du curseur                                       *
************************** Sorties **************************
* Rectangle de texte slctionn ou non                     *
************************************************************/
bool mouseInRectangle(SDL_Rect txt, int m_x, int m_y);

/******************** Nom de la fonction ********************
* printScores                                               *
*********************** Auteur  Dates ***********************
* Tho Chassaigne *** 20/12/2012                            *
************************ Description ************************
* Affiche les scores                                        *
************************** Entres **************************
* Fentre                                                   *
* Images et sprites                                         *
* Variable des vnements                                   *
* Police d'criture                                         *
*                                                           *
* Boolen de fermeture du programme                         *
************************** Sorties **************************
* Retour au menu ou quitte le programme                     *
************************************************************/
void printScores(SDL_Surface *screen, surfaces &SUR, SDL_Event &event, TTF_Font *font, bool &quit);

#endif // MENU_H_INCLUDED
